org.apache.ignite.internal.processors.cache.transactions

## Interface IgniteTxLocalEx

All Superinterfaces:
  AutoCloseable, GridTimeoutObject, IgniteInternalTx

All Known Implementing Classes:
  GridDhtTxLocal, GridDhtTxLocalAdapter, GridNearTxLocal, IgniteTxLocalAdapter

    public interface IgniteTxLocalEx
    extends IgniteInternalTx

Local transaction API.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.ignite.internal.processors.cache.transactions.IgniteInternalTx

`IgniteInternalTx.FinalizationStatus`

### Method Summary

Methods
`Throwable` `commitError()`
`boolean` `finish(boolean commit)` Finishes transaction (either commit or rollback).
`<K,V> IgniteInternalFuture<Map<K,V>>` `getAllAsync(GridCacheContext cacheCtx, AffinityTopologyVersion entryTopVer, Collection<KeyCacheObject> keys, boolean deserializeBinary, boolean skipVals, boolean keepCacheObjects, boolean skipStore, boolean needVer)`
`<K,V> IgniteInternalFuture<GridCacheReturn>` `invokeAsync(GridCacheContext cacheCtx, AffinityTopologyVersion entryTopVer, K key, javax.cache.processor.EntryProcessor<K,V,Object> entryProcessor, Object... invokeArgs)`
`<K,V,T> IgniteInternalFuture<GridCacheReturn>` `invokeAsync(GridCacheContext cacheCtx, AffinityTopologyVersion entryTopVer, Map<? extends K,? extends javax.cache.processor.EntryProcessor<K,V,Object>> map, Object... invokeArgs)`
`IgniteInternalFuture<Void>` `loadMissing(GridCacheContext cacheCtx, AffinityTopologyVersion topVer, boolean readThrough, boolean async, Collection<KeyCacheObject> keys, boolean skipVals, boolean needVer, boolean keepBinary, GridInClosure3<KeyCacheObject,Object,GridCacheVersion> c)`
`GridCacheVersion` `minVersion()`
`<K,V> IgniteInternalFuture<GridCacheReturn>` `putAllAsync(GridCacheContext cacheCtx, AffinityTopologyVersion entryTopVer, Map<? extends K,? extends V> map, boolean retval)`
`IgniteInternalFuture<?>` `putAllDrAsync(GridCacheContext cacheCtx, Map<KeyCacheObject,GridCacheDrInfo> drMap)`
`<K,V> IgniteInternalFuture<GridCacheReturn>` `putAsync(GridCacheContext cacheCtx, AffinityTopologyVersion entryTopVer, K key, V val, boolean retval, CacheEntryPredicate filter)`
`<K,V> IgniteInternalFuture<GridCacheReturn>` `removeAllAsync(GridCacheContext cacheCtx, AffinityTopologyVersion entryTopVer, Collection<? extends K> keys, boolean retval, CacheEntryPredicate filter, boolean singleRmv)`
`IgniteInternalFuture<?>` `removeAllDrAsync(GridCacheContext cacheCtx, Map<KeyCacheObject,GridCacheVersion> drMap)`
`void` `userCommit()`
`void` `userRollback()`

### Methods inherited from interface org.apache.ignite.internal.processors.cache.transactions.IgniteInternalTx

`activeCachesDeploymentEnabled, addInvalidPartition, addMeta, allEntries, alternateVersions, close, colocated, commit, commitAsync, commitError, commitVersion, commitVersion, completedVersions, concurrency, currentPrepareFuture, dht, done, empty, endVersion, entry, errorWhenCommitting, eventNodeId, finishFuture, hasTransforms, hasWriteKey, implicit, implicitSingle, internal, invalidate, invalidPartitions, ioPolicy, isInvalidate, isolation, isRollbackOnly, isSystemInvalidate, local, localResult, markFinalizing, markPreparing, masterNodeIds, meta, near, nearXidVersion, needsCompletedVersions, nodeId, onePhaseCommit, onOwnerChanged, onRemap, optimistic, optimisticLockEntries, originatingNodeId, otherNodeId, ownedVersion, ownsLock, ownsLockUnsafe, peek, pessimistic, prepare, prepareAsync, proxy, readCommitted, readEntries, readMap, readSet, remainingTime, removeMeta, repeatableRead, replicated, rollback, rollbackAsync, seal, serializable, setRollbackOnly, size, startTime, state, state, storeEnabled, storeUsed, subjectId, syncMode, system, systemInvalidate, taskNameHash, threadId, timedOut, timeout, timeout, topologyVersion, topologyVersion, topologyVersionSnapshot, transactionNodes, txState, user, writeEntries, writeMap, writeSet, writeVersion, writeVersion, xid, xidVersion`

### Methods inherited from interface org.apache.ignite.internal.processors.timeout.GridTimeoutObject

`endTime, onTimeout, timeoutId`

### Method Detail

#### minVersion

    GridCacheVersion minVersion()

Returns:
  Minimum version involved in transaction.

#### commitError

    @Nullable
    Throwable commitError()

Returns:
  Commit error.

#### userCommit

    void userCommit()
                    throws IgniteCheckedException

Throws:
  `IgniteCheckedException` - If commit failed.

#### userRollback

    void userRollback()
                      throws IgniteCheckedException

Throws:
  `IgniteCheckedException` - If rollback failed.

#### getAllAsync

    <K,V> IgniteInternalFuture<Map<K,V>> getAllAsync(GridCacheContext cacheCtx,
                                                   @Nullable
                                                   AffinityTopologyVersion entryTopVer,
                                                   Collection<KeyCacheObject> keys,
                                                   boolean deserializeBinary,
                                                   boolean skipVals,
                                                   boolean keepCacheObjects,
                                                   boolean skipStore,
                                                   boolean needVer)

Parameters:
  `cacheCtx` - Cache context.
  `keys` - Keys to get.
  `deserializeBinary` - Deserialize binary flag.
  `skipVals` - Skip values flag.
  `keepCacheObjects` - Keep cache objects
  `skipStore` - Skip store flag.
Returns:
  Future for this get.

#### putAllAsync

    <K,V> IgniteInternalFuture<GridCacheReturn> putAllAsync(GridCacheContext cacheCtx,
                                                          @Nullable
                                                          AffinityTopologyVersion entryTopVer,
                                                          Map<? extends K,? extends V> map,
                                                          boolean retval)

Parameters:
  `cacheCtx` - Cache context.
  `map` - Map to put.
  `retval` - Flag indicating whether a value should be returned.
Returns:
  Future for put operation.

#### putAsync

    <K,V> IgniteInternalFuture<GridCacheReturn> putAsync(GridCacheContext cacheCtx,
                                                       @Nullable
                                                       AffinityTopologyVersion entryTopVer,
                                                       K key,
                                                       V val,
                                                       boolean retval,
                                                       CacheEntryPredicate filter)

Parameters:
  `cacheCtx` - Cache context.
  `key` - Key.
  `val` - Value.
  `retval` - Return value flag.
  `filter` - Filter.
Returns:
  Future for put operation.

#### invokeAsync

    <K,V> IgniteInternalFuture<GridCacheReturn> invokeAsync(GridCacheContext cacheCtx,
                                                          @Nullable
                                                          AffinityTopologyVersion entryTopVer,
                                                          K key,
                                                          javax.cache.processor.EntryProcessor<K,V,Object> entryProcessor,
                                                          Object... invokeArgs)

Parameters:
  `cacheCtx` - Cache context.
  `key` - Key.
  `entryProcessor` - Entry processor.
  `invokeArgs` - Optional arguments for entry processor.
Returns:
  Operation future.

#### invokeAsync

    <K,V,T> IgniteInternalFuture<GridCacheReturn> invokeAsync(GridCacheContext cacheCtx,
                                                            @Nullable
                                                            AffinityTopologyVersion entryTopVer,
                                                            Map<? extends K,? extends javax.cache.processor.EntryProcessor<K,V,Object>> map,
                                                            Object... invokeArgs)

Parameters:
  `cacheCtx` - Cache context.
  `map` - Entry processors map.
  `invokeArgs` - Optional arguments for entry processor.
Returns:
  Operation future.

#### removeAllAsync

    <K,V> IgniteInternalFuture<GridCacheReturn> removeAllAsync(GridCacheContext cacheCtx,
                                                             @Nullable
                                                             AffinityTopologyVersion entryTopVer,
                                                             Collection<? extends K> keys,
                                                             boolean retval,
                                                             CacheEntryPredicate filter,
                                                             boolean singleRmv)

Parameters:
  `cacheCtx` - Cache context.
  `keys` - Keys to remove.
  `retval` - Flag indicating whether a value should be returned.
  `filter` - Filter.
  `singleRmv` - `True` for single key remove operation (`Cache.remove(Object)`.
Returns:
  Future for asynchronous remove.

#### putAllDrAsync

    IgniteInternalFuture<?> putAllDrAsync(GridCacheContext cacheCtx,
                                        Map<KeyCacheObject,GridCacheDrInfo> drMap)

Parameters:
  `cacheCtx` - Cache context.
  `drMap` - DR map to put.
Returns:
  Future for DR put operation.

#### removeAllDrAsync

    IgniteInternalFuture<?> removeAllDrAsync(GridCacheContext cacheCtx,
                                           Map<KeyCacheObject,GridCacheVersion> drMap)

Parameters:
  `cacheCtx` - Cache context.
  `drMap` - DR map.
Returns:
  Future for asynchronous remove.

#### finish

    boolean finish(boolean commit)
                   throws IgniteCheckedException

Finishes transaction (either commit or rollback).

Parameters:
  `commit` - `True` if commit, `false` if rollback.
Returns:
  `True` if state has been changed.
Throws:
  `IgniteCheckedException` - If finish failed.

#### loadMissing

    IgniteInternalFuture<Void> loadMissing(GridCacheContext cacheCtx,
                                         AffinityTopologyVersion topVer,
                                         boolean readThrough,
                                         boolean async,
                                         Collection<KeyCacheObject> keys,
                                         boolean skipVals,
                                         boolean needVer,
                                         boolean keepBinary,
                                         GridInClosure3<KeyCacheObject,Object,GridCacheVersion> c)

Parameters:
  `cacheCtx` - Cache context.
  `readThrough` - Read through flag.
  `async` - if `True`, then loading will happen in a separate thread.
  `keys` - Keys.
  `skipVals` - Skip values flag.
  `needVer` - If `true` version is required for loaded values.
  `c` - Closure to be applied for loaded values.
Returns:
  Future with `True` value if loading took place.

2015 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 1.6.0
Release Date | : May 18 2016